// conventional FIR filter function

float fast_fir(float in, float coef[], float buf[], unsigned *index, unsigned length) {
  float    out;
  unsigned i;

  buf[*index]=in;
  *index=(*index+1)%length;
  out=0.0;
  for (i=0; i<length; i=i+1) out=out+coef[i]*buf[(*index+i)%length];
  return out;
}
